from functools import partial

from application.ScriptResetActivatedEvent import ScriptResetActivatedEvent
from application.control_surface.ActionGroupInterface import ActionGroupInterface
from domain.lom.set.SessionToArrangementService import SessionToArrangementService
from domain.shared.event.DomainEventBus import DomainEventBus


class ActionGroupSet(ActionGroupInterface):
    CHANNEL = 3

    def configure(self):
        # type: () -> None
        # INIT song encoder
        self.add_encoder(
            identifier=4,
            name="(re) initialize the script",
            on_press=partial(DomainEventBus.emit, ScriptResetActivatedEvent()),
        )

        # Session2ARrangement encoder
        self.add_encoder(
            identifier=16,
            name="bounce session to arrangement",
            on_press=self._container.get(SessionToArrangementService).bounce_session_to_arrangement,
        )
