from functools import wraps

from typing import Any

from shared.types import Func


def handle_error(func):
    # type: (Func) -> Func
    @wraps(func)
    def decorate(*a, **k):
        # type: (Any, Any) -> Any
        # noinspection PyBroadException
        try:
            return func(*a, **k)
        except Exception:
            from domain.shared.event.DomainEventBus import DomainEventBus
            from domain.shared.errors.ErrorRaisedEvent import ErrorRaisedEvent

            DomainEventBus.emit(ErrorRaisedEvent())

    return decorate
