from typing import cast

from domain.lom.clip.Clip import Clip
from domain.lom.clip.ClipConfig import ClipConfig
from shared.Song import Song
from tests.domain.fixtures.clip_slot import AbletonClipSlot
from tests.domain.fixtures.p0 import make_protocol0


def test_clip_playing_position():
    make_protocol0()
    clip_slot = Song.selected_track().clip_slots[0]
    live_clip_slot = cast(AbletonClipSlot, clip_slot._clip_slot)
    live_clip_slot.add_clip()
    live_clip_slot.clip.length = 4
    clip = Clip(live_clip_slot.clip, 1, ClipConfig(1))
    assert clip.playing_position.position == 0

    live_clip_slot.clip.length = 16
    live_clip_slot.clip.playing_position = 5.0
    clip = Clip(live_clip_slot.clip, 2, ClipConfig(2))
    assert clip.playing_position.position == 5
